#include <compiler.h>

using namespace LTF;

bool Type::setInline()
{
	if(this->Inline || this->NoRef || this->NoLock) return false;
	this->Inline = true;
	return true;
}

bool Type::setNoRef()
{
	if(this->Inline || this->NoRef || this->NoLock) return false;
	this->NoRef = true;
	return true;
}

bool Type::setNoLock()
{
	if(this->Inline || this->NoRef || this->NoLock) return false;
	this->NoLock = true;
	return true;
}

bool Type::setParent(Type *pt)
{
	if(this->parent == NULL) return false;
	this->parent = pt;
	return (this->parent != NULL);
}

bool Type::isInline()
{
	return this->Inline;
}

bool Type::addMember(TypeVariableAST *v)
{
	this->Members->insert(std::pair<std::string, TypeVariableAST *>(*v->getName(), v));
	return true;
}

bool Type::addFunction(FunctionAST *f)
{
	this->Functions.push_back(f);
	return true;
}

int Type::countArguments()
{
	int args = 0;
	for(std::map<std::string, TypeVariableAST *>::iterator iter = this->Members->begin(); iter != this->Members->end(); iter++) {
		if(iter->second->getInit()) args++;
	}
	return args;
}
